#ifndef AWARENETCHANNEL_H
#define AWARENETCHANNEL_H

// Copyright (C) 2010 Nokia
// All rights reserved. Nokia internal use only.
// See LICENCE for details.
//
// Author:
// Janne Noyranen <janne.noyranen@nokia.com>


#include <QObject>
#include "message.h"

namespace AwareNet
{
    // Forward declarations
    class ChannelPrivate;

    class Channel : public QObject
    {
    Q_OBJECT
    Q_DISABLE_COPY(Channel)

    public:
        Channel(QObject *parent = 0);

        // Emits channelReady() or channelError(int )
        int bind(quint32 channelId);

        int sendMessage(const UnicastMessage& message);
        int sendMessage(const BroadcastMessage& message);

    signals:
        void channelReady();
        void channelError(int reason);
        void messageReceived(const ReceivedMessage &message);

    protected:
        ChannelPrivate * const d_ptr;
        Q_DECLARE_PRIVATE(Channel);
    };

} // namespace AwareNet

#endif // AWARENETCHANNEL_H
