#ifndef COMMUNITY_H
#define COMMUNITY_H

// Copyright (C) 2010 Nokia
// All rights reserved. Nokia internal use only.
// See LICENCE for details.
//
// Author:
// Janne Noyranen <janne.noyranen@nokia.com>


#include <QObject>
#include <QMetaType>

namespace AwareNet
{

    class Community : public QObject
    {
    Q_OBJECT

    public:
        enum CommunityType {
            Public,     // No encryption
            Private,    // Shared key encryption
            Personal,   // Someone's personal community
            OwnPersonal // Devices own personal community
        };

    private:
        Community(QObject *parent = 0);

    public:
        quint8 getCommunityType() const;
        QString getDescription() const;
        void setActive(bool value);
        void showUserAlias(bool value);
        bool isActive() const;
        bool isUserAliasShown() const;

    public: // TODO: TEMP SOLUTION: make private class to hide/access these
        quint32 handle;
        quint8 communityType;
        QString description;
        bool _isActive;
        bool _showUserAlias;
    };

} // namespace AwareNet

Q_DECLARE_METATYPE(AwareNet::Community *)

#endif // COMMUNITY_H
