#ifndef DEVICEINFO_H
#define DEVICEINFO_H

// Copyright (C) 2010 Nokia
// All rights reserved. Nokia internal use only.
// See LICENCE for details.
//
// Author:
// Janne Noyranen <janne.noyranen@nokia.com>


#include <QObject>
#include <qdatetime.h>
#include "deviceaddress.h"

namespace AwareNet
{
    // Forward declarations
    class DeviceInfoPrivate;
    class Connection;

    class DeviceInfo
    {
    public:
        DeviceInfo();
        DeviceInfo(const DeviceInfo &other);
        ~DeviceInfo();

        DeviceAddress address() const;
        bool isNear() const;
        bool isKnown() const;
        QDateTime receivedLastMessage() const;
        QDateTime receivedLastNearMessage() const;

    private:
        friend class Connection;
        DeviceInfoPrivate * const d_ptr;
        Q_DECLARE_PRIVATE(DeviceInfo);
    };


    class DeviceInfoPrivate
    {
    private:
        DeviceInfoPrivate(DeviceInfo *pub);

    private:
        DeviceAddress address;
        bool isNear;
        bool isKnown;
        QDateTime receivedLastMessage;
        QDateTime receivedLastNearMessage;

    private:
        friend class Connection;
        DeviceInfo * const q_ptr;
        Q_DECLARE_PUBLIC(DeviceInfo);
    };

} // namespace AwareNet

Q_DECLARE_METATYPE(AwareNet::DeviceInfo)

#endif // DEVICEINFO_H
