CONFIG += qt silent

QT += xml maemo5 sql

TARGET = nebia

QMAKE_CXXFLAGS+=-O3 -Wextra -fstack-protector -Wundef -Wpointer-arith
QMAKE_CXXFLAGS+=-Wconversion -Winit-self -Wuninitialized -Wstrict-null-sentinel
#QMAKE_CXXFLAGS+=-Werror -g

QMAKE_LFLAGS+=-as-needed

# keep the tree clean
DESTDIR = build
OBJECTS_DIR = build
MOC_DIR = src/.tmp
# In Eclipse, "clean" removes binaries too.  This is also needed to work around timestamp
# issues between host and VM in ESbox.
QMAKE_CLEAN += $$DESTDIR/nebia

HEADERS     = src/window.h \
              src/Network/MessageFormatter.h \
              src/Network/MessageParser.h \
              src/Network/ChannelListener.h \
              src/Network/ChannelSender.h \
              src/type.h \
              src/Dialogs/LogDialog.h \
              src/Dialogs/ActivityChooserWidget.h \
              src/Dialogs/PendingRequest.h \
              src/Dialogs/UserPreferencesDialog.h \
              src/Dialogs/ActivitySelection.h \
              src/Dialogs/ButtonListWidget.h \
              src/Dialogs/ActivityConfirmationDialog.h \
              src/Dialogs/TextDialog.h \
              src/Dialogs/ParametersDialog.h \
              src/Activities/ActivityLoader.h \
              src/Activities/ActivityManager.h \
              src/Activities/Activity.h \
              src/Storage/ActivityLog.h \
              src/Requests/Request.h \
              src/Requests/RequestsManager.h \
              src/Requests/ClientRequest.h \
              src/User.h \
              src/UserParameters.h


SOURCES     = src/window.cpp \
              src/main.cpp \
              src/Network/MessageFormatter.cpp \
              src/Network/ChannelSender.cpp \
              src/Network/MessageParser.cpp \
              src/Network/ChannelListener.cpp \
              src/Dialogs/PendingRequest.cpp \
              src/Dialogs/ButtonListWidget.cpp \
              src/Dialogs/ActivitySelection.cpp \
              src/Dialogs/LogDialog.cpp \
              src/Dialogs/ActivityConfirmationDialog.cpp \
              src/Dialogs/UserPreferencesDialog.cpp \
              src/Dialogs/ActivityChooserWidget.cpp \
              src/Dialogs/ParametersDialog.cpp \
              src/Dialogs/TextDialog.cpp \
              src/Activities/ActivityManager.cpp \
              src/Activities/Activity.cpp \
              src/Activities/ActivityLoader.cpp \
              src/Storage/ActivityLog.cpp \
              src/Requests/Request.cpp \
              src/Requests/ClientRequest.cpp \
              src/Requests/RequestsManager.cpp \
              src/User.cpp \
              src/UserParameters.cpp

# TEMPLATE = app
# DESTDIR = /path/to/installation
# DEFINES += MACRO_1 ...

# CONFIG += link_pkgconfig
# PKGCONFIG += ogg dbus-1

# install
target.path = /usr/bin
INSTALLS += target

maemo5 {
    #VARIABLES
    isEmpty(PREFIX) {
        PREFIX = /usr/local
    }

    INCLUDEPATH += /usr/include/awarenetcore
    INCLUDEPATH += ../libawarenet/include/awarenetcore
    INCLUDEPATH += ../nebia/libawarenet/include/awarenetcore
    LIBS +=  -L../nebia/libawarenet/lib \
             -L../libawarenet/lib \
             -lawarenetcore \
             -lawarenetmessages \
             -lawarenetcoreservices


    #VARIABLES
    isEmpty(PREFIX) {
        PREFIX = /usr
    }
    BINDIR = $$PREFIX/bin
    DATADIR =$$PREFIX/share

    DEFINES += DATADIR=\\\"$$DATADIR\\\" PKGDATADIR=\\\"$$PKGDATADIR\\\"http://doc.qt.nokia.com/latest/qmake-project-files.html

    INSTALLS += target desktop icon48 activities
    target.path = $$BINDIR

    desktop.path = $$DATADIR/applications/hildon
    desktop.files += data/nebia.desktop

    icon48.path = $$DATADIR/icons/hicolor/48x48/apps
    icon48.files += data/nebia.png

    activities.path = /opt/nebia/data
    activities.files += data/activities.xml

} else {
    # We want to enable building also outside scratchbox
    # but inside the awarenetcore source tree
    INCLUDEPATH += ../../api ../../common \
               ../../services/messaging
    LIBS += -L../../api -lawarenetcore \
    -L.././messages -lawarenetmessages \
    -L../../services -lawarenetcoreservices
}
