/*
 * Activity.h
 *
 *  Created on: Oct 14, 2010
 *      Author: Remi Boch
 */

#ifndef ACTIVITY_H_
#define ACTIVITY_H_

#include "../type.h"

class Activity {
public:
        Activity(QString name, QString category);
	virtual ~Activity();
	Activity(const Activity &);

	QString getName() const;
        QString getCategory() const;
        QString getHash() const;

        QString toHashedXMLEntry() const;
        QString toXMLEntry() const;

	bool operator==(const Activity &toCompare) const;
	bool operator!=(const Activity &toCompare) const;
	bool operator<(const Activity &toCompare) const;
	Activity& operator=(const Activity &);
private:
	QString name;
        QString category;
};

QTextStream &operator<<(QTextStream &out, const Activity &activity);
uint qHash(const Activity &);

#endif /* ACTIVITY_H_ */
