/*
 * ActivityChooserWidget.h
 *
 *  Created on: Nov 10, 2010
 *      Author: maemo
 */

#ifndef ACTIVITYCHOOSERWIDGET_H_
#define ACTIVITYCHOOSERWIDGET_H_

#include "../type.h"
#include <QWidget>
#include <QVBoxLayout>
#include <QCheckBox>
#include <QScrollArea>
#include <QTextStream>

#include "../Activities/Activity.h"
class ActivityChooserWidget : public QWidget {
	Q_OBJECT;
public:
        ActivityChooserWidget(const QSet<Activity> &activities,QWidget *parent = 0);
	ActivityChooserWidget(const ActivityChooserWidget &);
	ActivityChooserWidget& operator=(const ActivityChooserWidget &);
	virtual ~ActivityChooserWidget();
        QSet<Activity>* getChosenActivities() const;
        QSet<Activity> getAllActivities() const;
	void selectActivitiesCheckBoxes(QSet<Activity>* activities);
	void resetActivitiesCheckBoxes();

private:
        QSet<Activity>* activities;
	QScrollArea* scrollArea;
	QWidget* areaWidget;
	QVBoxLayout* areaWidgetLayout;
	QVBoxLayout* widgetLayout;
	QMap<Activity, QCheckBox*> *activitiesCheckboxes;
	void initLayout();
	void initCheckboxes();
};

#endif /* ACTIVITYCHOOSERWIDGET_H_ */
