/*
 * ButtonListWidget.cpp
 *
 *  Created on: Nov 10, 2010
 *      Author: maemo
 */

#include "ButtonListWidget.h"

ButtonListWidget::ButtonListWidget(QList<Activity>* activities,QWidget *parent)
: QWidget(parent){
	buttons = new QList<QPushButton*>();
	scrollArea = new QScrollArea(this);
	scrollArea->setWidgetResizable(true);
	scrollAreaWidget = new QWidget();
	widgetLayout = new QVBoxLayout(scrollAreaWidget);
	signalMapper=new QSignalMapper(this);
        QList<QString>* foundCategories = new QList<QString>();
        QList<Activity>::const_iterator i;
        QString workingCategory;
        for (i = activities->begin(); i != activities->end(); ++i) {
            workingCategory = (*i).getCategory();
            if(!foundCategories->contains(workingCategory)){

                QPushButton* button = new QPushButton(workingCategory, scrollAreaWidget);
		buttons->append(button);
		widgetLayout->addWidget(button);
                signalMapper->setMapping(button, workingCategory);
		connect(button, SIGNAL(clicked()), signalMapper, SLOT(map()));
                foundCategories->append(workingCategory);
            }
	}

	scrollArea->setWidget(scrollAreaWidget);
	upperWidgetLayout = new QVBoxLayout();
	upperWidgetLayout->addWidget(scrollArea);
	widgetLayout->addStretch(50);
	setLayout(upperWidgetLayout);
}

ButtonListWidget::~ButtonListWidget() {
	delete buttons;
	delete widgetLayout;
	delete scrollAreaWidget;
	delete scrollArea;
}

QList<QPushButton*>* ButtonListWidget::getButtons(){
	return this->buttons;
}

QSignalMapper* ButtonListWidget::getSignalMapper(){
	return signalMapper;
}
