/*
 * ActivityConfirmationDialog.cpp
 *
 *  Created on: Nov 4, 2010
 *      Author: maemo
 */

#include "LogDialog.h"

LogDialog::LogDialog(QWidget * parent)
: QWidget(parent)
{
	setWindowTitle("Nebia - Activity Log");

	setAttribute(Qt::WA_Maemo5StackedWindow);
	setAttribute(Qt::WA_DeleteOnClose);
	setWindowFlags(windowFlags() | Qt::Window);

	QList<ClientRequest> requests = ActivityLog::getInstance()->getPastRequests();

	QScrollArea * scrollArea = new QScrollArea(this);
	QWidget * containerWidget = new QWidget(scrollArea);
	QVBoxLayout * mainLayout = new QVBoxLayout(containerWidget);

	QList<ClientRequest>::const_iterator i;
	for (i = requests.begin(); i != requests.end(); ++i) {
		mainLayout->addWidget(buildRequestWidget(*i));
	}

	scrollArea->setWidgetResizable(true);
	scrollArea->setWidget(containerWidget);

	QGridLayout * windowLayout = new QGridLayout(this);
	windowLayout->addWidget(scrollArea);
	setLayout(windowLayout);
}

QWidget* LogDialog::buildRequestWidget(const ClientRequest &request) {
	QGroupBox * requestWidget = new QGroupBox();
	QVBoxLayout * requestLayout = new QVBoxLayout(requestWidget);

	QLabel * invitedLabel = new QLabel(tr("Invited by: ") + request.getUser().getName());
	QLabel * numberLabel = new QLabel(QString::number(request.getUsers().size()+1) + tr(" participants"));
        QLabel * activityLabel = new QLabel(tr("Played: ") + request.getActivity().getName());
	QLabel * messageLabel = new QLabel(tr("Message: ") + request.getMessage());
	messageLabel->setWordWrap(true);

	requestLayout->addWidget(invitedLabel);
	requestLayout->addWidget(activityLabel);
	requestLayout->addWidget(numberLabel);
	requestLayout->addWidget(messageLabel);

	QString datePart = request.getDate();
	requestWidget->setTitle(datePart);

	return requestWidget;
}
