/*
 * ResponseDialog.cpp
 *
 *  Created on: Oct 21, 2010
 *      Author: maemo
 */

#include "ParametersDialog.h"

ParametersDialog::ParametersDialog(QWidget *parent) : QDialog(parent) {

	setWindowTitle("Parameters");

	QHBoxLayout* dialogLayout = new QHBoxLayout(this);

	// Begin main
	QWidget *paramWidget = new QWidget(this);
	QVBoxLayout *mainLayout = new QVBoxLayout(paramWidget);

	QWidget *usernameWidget = new QWidget(paramWidget);
	QHBoxLayout *usernameLayout = new QHBoxLayout(usernameWidget);

	QLabel *username = new QLabel(tr("Username: "));
	nameEdit = new QLineEdit(paramWidget);
	nameEdit->setText(UserParameters::getInstance()->getUser()->getName());

	usernameLayout->addWidget(username);
	usernameLayout->addWidget(nameEdit);

	mainLayout->addWidget(usernameWidget);
	// End main

	// Begin buttons
	QPushButton *ok = new QPushButton("Save", this);
	QPushButton *cancel = new QPushButton("Cancel", this);

	connect(ok, SIGNAL(clicked()), this, SLOT(onOkClicked()));
	connect(cancel, SIGNAL(clicked()), this, SLOT(onCancelClicked()));

	QVBoxLayout *buttonLayout = new QVBoxLayout();

	buttonLayout->addWidget(ok);
	buttonLayout->addWidget(cancel);

	QGroupBox *buttonBox = new QGroupBox(this);
	buttonBox->setLayout(buttonLayout);
	// End buttons

	dialogLayout->addWidget(paramWidget,3);
	dialogLayout->addWidget(buttonBox,1);
	setLayout(dialogLayout);

}

ParametersDialog::~ParametersDialog() {

}

void ParametersDialog::onOkClicked() {
	QString newname = nameEdit->text();
	UserParameters::getInstance()->setUsername(newname);
	done(QDialog::Accepted);
}

void ParametersDialog::onCancelClicked() {
	done(QDialog::Rejected);
}
