/*
 * UserPreferencesDialog.h
 *
 *  Created on: Nov 2, 2010
 *      Author: maemo
 */

#ifndef USERPREFERENCESDIALOG_H_
#define USERPREFERENCESDIALOG_H_

#include "../type.h"
#include <QWidget>
#include <QPushButton>
#include <QGridLayout>
#include <QScrollArea>
#include <QSignalMapper>
#include "ActivityChooserWidget.h"
#include "ButtonListWidget.h"
#include <QFile>
#include <QTextStream>

#include "../Activities/Activity.h"
#include "../Activities/ActivityLoader.h"

class UserPreferencesDialog : public QWidget {
	Q_OBJECT;
public:
	UserPreferencesDialog(QWidget *parent = 0);
	virtual ~UserPreferencesDialog();
	void initPannel();
public slots:
	void onResetClicked();
	void onSaveClicked();
	void onCategoryButtonClicked(QString category);
private:
	void showActivityList(ActivityChooserWidget* wid);
	QPushButton* reset;
	QPushButton* save;
	QGridLayout* gridMainLayout;
	ButtonListWidget* buttonList;
	QMap<QString,ActivityChooserWidget*> *activitychoosers;
	ActivityChooserWidget* currentlyDisplayed;
};

#endif /* USERPREFERENCESDIALOG_H_ */
