/*
 * ChannelListener.h
 *
 *  Created on: Oct 14, 2010
 *      Author: maemo
 */

#ifndef CHANNELLISTENER_H_
#define CHANNELLISTENER_H_

#include "../type.h"

#include "channel.h"
#include "message.h"

#include "../Activities/Activity.h"
#include "../Activities/ActivityManager.h"

#include "../Requests/ClientRequest.h"
#include "../Requests/RequestsManager.h"

#include "../Storage/ActivityLog.h"

#include "../Dialogs/ActivitySelection.h"
#include "../Dialogs/LogDialog.h"

#include "../User.h"
#include "../UserParameters.h"

#include "MessageParser.h"
#include "ChannelSender.h"
#include "MessageFormatter.h"

#include <QMaemo5InformationBox>

using namespace AwareNet;

class ChannelListener : public QObject {
	Q_OBJECT
	public:
	    explicit ChannelListener(QObject *parent = 0);

	public slots:
	    void onChannelReady();
	    void onChannelError(int errorCode);
	    void onMessageReceived(const ReceivedMessage &msg);

	private:
	    Channel *m_channel;
	    ChannelSender sender;

	    QObject * parentWindow;

	    ChannelListener(const ChannelListener&);
	    ChannelListener& operator=(const ChannelListener&);

	    void onInvitationReceived(QString payload, QString senderAddress);
	    void onParticipationReceived(QString payload, QString senderAddress);
	    void onConfirmationReceived(QString payload);
	    void onCancellationReceived(QString payload);

};
#endif /* CHANNELLISTENER_H_ */
