/*
 * ChannelSender.h
 *
 *  Created on: Oct 14, 2010
 *      Author: Remi Bloch
 */

#ifndef CHANNELSENDER_H_
#define CHANNELSENDER_H_

#include "../type.h"

class ChannelSender : public QObject{
	Q_OBJECT
	public:
		ChannelSender(QObject *parent = 0);

		void sendBroadcast(const QString&);
		void sendUnicast(const QString&, const DeviceAddress&);
		bool channelReady();

	public slots:
		void onChannelReady();
		void onChannelError(int errorCode);

	private:
		ChannelSender(ChannelSender &sender);
		ChannelSender& operator=(const ChannelSender&);

		AwareNet::Channel *m_channel;
		bool isReady;
};

#endif /* CHANNELSENDER_H_ */
