/*
 * MessageFormatter.cpp
 *
 *  Created on: Oct 19, 2010
 *      Author: maemo
 */

#include "MessageFormatter.h"

MessageFormatter::MessageFormatter() {
	// TODO Auto-generated constructor stub

}

MessageFormatter::~MessageFormatter() {
	// TODO Auto-generated destructor stub
}


QString MessageFormatter::request(const User &user, const Request &request, const QList<Activity> &activities) {
    QString result;

    result += "<request protocol='nebia-1'>";
    result += "<rid>" + request.getIdentifier() + "</rid>";

    QList<Activity>::const_iterator i;
    for (i = activities.begin(); i != activities.end(); i++) {
        result += (*i).toXMLEntry();
    }

    result += "<sendername id='" + user.getIdentifier() + "'>" + user.getName() + "</sendername>";
    result += "</request>";

    return result;
}

QString MessageFormatter::presence(const User &participant, const Request &request, const QList<Activity> &activities, int presence) {
    QString result;

    result += "<answer protocol='nebia-1'>";

    result += "<rid>" + request.getIdentifier() + "</rid>";

    QList<Activity>::const_iterator i;
    for (i = activities.begin(); i != activities.end(); i++) {
        result += (*i).toXMLEntry();
    }

    result += "<sendername id='" + participant.getIdentifier() + "'>" + participant.getName() + "</sendername>";
    result += "<presence>";
    result += QString::number(presence);
    result += "</presence>";

    result += "</answer>";

    return result;

}

QString MessageFormatter::confirmation(const Request &request, const Activity &activity, const QSet<User> &participants, const QString &msg) {
    /*
	 *	<confirmation protocol="nebia-1">
	 *		<rid>same id</rid>
	 *		<activity id="BALL" category="CAT" />
	 *		<username id='uid'>Alice</username>
	 *		<username id='uid'>Bob</username>
	 *		<username id='uid'>Eve</username>
	 *		<message>A message for the participants</message>
	 *	</confirmation>
	 */

    QString result;

    result += "<confirmation protocol='nebia-1'>";
    result += "<rid>" + request.getIdentifier() + "</rid>";
    result += activity.toXMLEntry();

    QSet<User>::const_iterator i;
    for (i=participants.begin(); i != participants.end(); i++) {
    	result += (*i).toXMLEntry();
    }

    result += "<message>";
    result += msg;
    result += "</message>";

    result += "</confirmation>";

    return result;
}

QString MessageFormatter::cancellation(const Request &request) {
	/*
	 *	<cancellation protocol="nebia-1">
	 *		<rid>same id</rid>
	 *	</cancellation>
	 */

	QString result;

	result += "<cancellation protocol='nebia-1'>";
	result += "<rid>" + request.getIdentifier() + "</rid>";
    result += "</cancellation>";

    return result;
}
