/*
 * MessageParser.h
 *
 *  Created on: Oct 14, 2010
 *      Author: maemo
 */

#ifndef MESSAGEPARSER_H_
#define MESSAGEPARSER_H_

#include "../type.h"

#include <QXmlStreamReader>
#include <QDomDocument>
#include <QDomElement>
#include <QDomNodeList>

#include "../Activities/Activity.h"
#include "../Activities/ActivityManager.h"

#include "../User.h"

#define NEBIA_CURRENT_PROTOCOL "nebia-1"

class MessageParser
{
private:
	MessageParser();
	virtual ~MessageParser();

public:
	static int parseType(const QString &payload);
        static QHash<QString, Activity> parseInvitation(const QString& payload, User*& user, QString &invitationId);
        static QHash<QString, Activity> parseParticipation(const QString& payload, User*& user, QString &invitationId, int &presence);
        static QSet<User> parseConfirmation(const QString &payload, QString &invitationId, Activity*& activity, QString &message);
	static void parseCancellation(const QString &payload, QString & requestId);
};

#endif /* MESSAGEPARSER_H_ */
