/*
 * ClientRequest.h
 *
 *  Created on: Nov 19, 2010
 *      Author: maemo
 */

#ifndef CLIENTREQUEST_H_
#define CLIENTREQUEST_H_

class ClientRequest;

#include "../type.h"
#include "../User.h"

#include "../Requests/Request.h"
#include "../Activities/Activity.h"

class ClientRequest {
public:
	ClientRequest(const User&, const Activity&, const QSet<User>&, QString, QString);
	ClientRequest(const User&, const Activity&, QString, QString);
	ClientRequest(const ClientRequest &);

	virtual ~ClientRequest();
	ClientRequest(const Request&, const Activity&, QString, QString);

	bool operator==(const ClientRequest &) const;

	User getUser() const;
	QString getDate() const;
	QString getMessage() const;
	const QSet<User>& getUsers() const;
	Activity getActivity() const;

private:
	ClientRequest& operator=(const ClientRequest &);

	User * user;
	QSet<User>* participants;
	Activity * activity;
	QString date;
	QString message;
};

QTextStream &operator<<(QTextStream &out, const ClientRequest &request);

#endif /* CLIENTREQUEST_H_ */
