/*
 * Request.h
 *
 *  Created on: Oct 19, 2010
 *      Author: maemo
 */

#ifndef REQUEST_H_
#define REQUEST_H_

class Request;

#include "../type.h"

#include "../User.h"
#include "../UserParameters.h"

#include "../Activities/Activity.h"
#include "../Activities/ActivityManager.h"

#include "network.h"

#include <QtCore/QUuid>

class Request {
public:
	Request();
	Request(const User &);
	Request(const User &, const QString&, const QString&);
	virtual ~Request();
	Request(const Request &);

	static Request Invalid();

	QString getIdentifier() const;
	QString getHostDevice() const;
	User getUser() const;

	QSet<User> * getUsers() const;
	QSet<User> * getUsers(const Activity&) const;
	QSet<User> * getUsersNotIn(const Activity&) const;
	QSet<Activity> * getActivities() const;

        bool addUser(const User &user, const QHash<QString, Activity> &activitiesList);

	int getAge() const;
	void increaseAge(int);

	Request& operator=(const Request &);

	bool operator==(const Request & that);
	bool operator!=(const Request & that);

private:
	QString identifier;
	QString deviceId;
	User * user;
	QHash<Activity,QSet<User>*> * possibleActivities;
	int age;
};

QTextStream &operator<<(QTextStream &out, const Request &request);

#endif /* REQUEST_H_ */
