/*
 * RequestsManager.h
 *
 *  Created on: Oct 19, 2010
 *      Author: maemo
 */

#ifndef REQUESTSMANAGER_H_
#define REQUESTSMANAGER_H_

#include "../type.h"

#include "../Storage/ActivityLog.h"

#include "Request.h"

#include "../Network/ChannelSender.h"
#include "../Network/MessageFormatter.h"

class RequestsManager {
public:
	static RequestsManager * getInstance();
	bool addRequest(const Request &request);
	bool cancelRequest(QString identifier);
	bool confirmRequest(const QString& identifier, const Activity& activity, const QString &confirmationMsg);
	bool removeRequest(const QString& identifier);
	void setChannelSender(ChannelSender * sender);
	Request * getModifiableRequest(const QString& identifier) const;
	Request getConstRequest(const QString& identifier) const;


private:
	RequestsManager();
	QHash<QString,Request> * requests;
	static RequestsManager * _instance;
	ChannelSender * sender;
};

#endif /* REQUESTSMANAGER_H_ */
