/*
 * ActivityLog.h
 *
 *  Created on: Oct 22, 2010
 *      Author: Remi Bloch
 *              Thomas Schwery
 */

#ifndef ACTIVITYLOG_H_
#define ACTIVITYLOG_H_

class ActivityLog;

#include "../type.h"

#include "../Requests/ClientRequest.h"
#include "../User.h"

#include <QUuid>

#include <QSqlDatabase>
#include <QSqlQuery>
#include <QSqlError>
#include <QtCore/QVariant>
#include <QDateTime>

class ActivityLog {
public:
	static ActivityLog* getInstance();

	void storeRequest(const ClientRequest&);
	QList<ClientRequest> getPastRequests() const;
	QDateTime getLastUserAppearance(const User&) const;
	QDateTime getLastUserAppearance(const User&, const Activity&) const;

	User * getUserParameter() const;
	void setUserParameter(const User&);

private:
	ActivityLog();
	~ActivityLog();
	ActivityLog(const ActivityLog&);
	ActivityLog& operator=(const ActivityLog&);

	static ActivityLog * _instance;
	QSqlDatabase * _db;
};

#endif /* ACTIVITYLOG_H_ */
