/*
 * User.h
 *
 *  Created on: Oct 19, 2010
 *      Author: maemo
 */

#ifndef USER_H_
#define USER_H_

#include "type.h"

#include "Activities/Activity.h"

#include <QDateTime>

class User {
public:
	User(QString name, QString identifier);
	User(const User &); //Copy
	~User();

	QString getName() const;
	QString getIdentifier() const;
	QString getDeviceId() const;

	QString getUserLastAppearance() const;
	QString getUserLastAppearance(const Activity&) const;

	void setDeviceId(QString did);

	QString toXMLEntry() const;

	bool operator==(const User &toCompare) const;
	User& operator=(const User &);

	static User Invalid();

private:
	QString name;
	QString identifier;
	QString device;
};

QTextStream &operator<<(QTextStream &out, const User &user);
uint qHash(const User &);

#endif /* USER_H_ */
