/*
 * UserParameters.h
 *
 *  Created on: Oct 24, 2010
 *      Author: maemo
 */

#ifndef USERPARAMETERS_H_
#define USERPARAMETERS_H_

class UserParameters;

#include "type.h"
#include "User.h"

#include "Activities/ActivityManager.h"
#include "Activities/ActivityLoader.h"

#include "Storage/ActivityLog.h"

class UserParameters {
public:
	static UserParameters* getInstance();
	void toggleInvitationsReceptions(bool newValue);
	bool canReceiveInvitations();

	User* getUser();
	void setUsername(const QString&);

        QHash<QString, Activity> * getActivities();
        QHash<QString, QSet<Activity>*> * getCategorySortedActivities();
        QList<Activity>* getActivitiesList();
	void forceUserPrefsReload();

private:
	UserParameters();
	~UserParameters();
	UserParameters(UserParameters &);
	UserParameters& operator=(UserParameters&);

	bool invitationsAllowed;
	static UserParameters * _instance;
        QHash<QString, Activity> * activitiesMap;
	User * user;
};

#endif /* USERPARAMETERS_H_ */
