
#include <QWidget>
#include <QtGui>
#include <QWidget>
#include <QPushButton>
#include <QMainWindow>
#include <QWidgetAction>

#include <QSignalMapper>

#include "type.h"

#include "Network/ChannelSender.h"
#include "Network/MessageParser.h"
#include "Network/ChannelListener.h"
#include "Network/MessageFormatter.h"

#include "Requests/RequestsManager.h"

#include "Dialogs/ActivitySelection.h"
#include "Dialogs/ActivityChooserWidget.h"
#include "Dialogs/TextDialog.h"
#include "Dialogs/UserPreferencesDialog.h"
#include "Dialogs/LogDialog.h"
#include "Dialogs/ParametersDialog.h"
#include "Dialogs/PendingRequest.h"

#include "Activities/Activity.h"

#include "User.h"
#include "UserParameters.h"

class Window : public QMainWindow
{
    Q_OBJECT

public:
    Window();
    virtual ~Window();

public slots:
	void handlePressed();
	void processHelpMenu();
	void processPrefsMenu();
	void processAboutMenu();
	void processInvMenu();
	void processLogMenu();
	void processParamMenu();

private:
	QAction *actHelp;
	QAction *actPrefs;
	QAction *actAbout;
	QAction *actInv;
	QAction *actLog;
	QAction *actParams;

	ChannelSender sender;
	void initMenu();
};
